<?php

/* ***********************************************************
 * This file was automatically generated on 2016-06-30.      *
 *                                                           *
 * PHP Bindings Version 2.1.9                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Measures distance up to 40m with laser light
 */
class BrickletLaserRangeFinder extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletLaserRangeFinder::setDistanceCallbackPeriod(). The parameter is the distance value
     * of the sensor.
     * 
     * BrickletLaserRangeFinder::CALLBACK_DISTANCE is only triggered if the distance value has changed since the
     * last triggering.
     */
    const CALLBACK_DISTANCE = 20;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletLaserRangeFinder::setVelocityCallbackPeriod(). The parameter is the velocity value
     * of the sensor.
     * 
     * BrickletLaserRangeFinder::CALLBACK_VELOCITY is only triggered if the velocity has changed since the
     * last triggering.
     */
    const CALLBACK_VELOCITY = 21;

    /**
     * This callback is triggered when the threshold as set by
     * BrickletLaserRangeFinder::setDistanceCallbackThreshold() is reached.
     * The parameter is the distance value of the sensor.
     * 
     * If the threshold keeps being reached, the callback is triggered periodically
     * with the period as set by BrickletLaserRangeFinder::setDebouncePeriod().
     */
    const CALLBACK_DISTANCE_REACHED = 22;

    /**
     * This callback is triggered when the threshold as set by
     * BrickletLaserRangeFinder::setVelocityCallbackThreshold() is reached.
     * The parameter is the velocity value of the sensor.
     * 
     * If the threshold keeps being reached, the callback is triggered periodically
     * with the period as set by BrickletLaserRangeFinder::setDebouncePeriod().
     */
    const CALLBACK_VELOCITY_REACHED = 23;


    /**
     * @internal
     */
    const FUNCTION_GET_DISTANCE = 1;

    /**
     * @internal
     */
    const FUNCTION_GET_VELOCITY = 2;

    /**
     * @internal
     */
    const FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 3;

    /**
     * @internal
     */
    const FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 4;

    /**
     * @internal
     */
    const FUNCTION_SET_VELOCITY_CALLBACK_PERIOD = 5;

    /**
     * @internal
     */
    const FUNCTION_GET_VELOCITY_CALLBACK_PERIOD = 6;

    /**
     * @internal
     */
    const FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 7;

    /**
     * @internal
     */
    const FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 8;

    /**
     * @internal
     */
    const FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD = 9;

    /**
     * @internal
     */
    const FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD = 10;

    /**
     * @internal
     */
    const FUNCTION_SET_DEBOUNCE_PERIOD = 11;

    /**
     * @internal
     */
    const FUNCTION_GET_DEBOUNCE_PERIOD = 12;

    /**
     * @internal
     */
    const FUNCTION_SET_MOVING_AVERAGE = 13;

    /**
     * @internal
     */
    const FUNCTION_GET_MOVING_AVERAGE = 14;

    /**
     * @internal
     */
    const FUNCTION_SET_MODE = 15;

    /**
     * @internal
     */
    const FUNCTION_GET_MODE = 16;

    /**
     * @internal
     */
    const FUNCTION_ENABLE_LASER = 17;

    /**
     * @internal
     */
    const FUNCTION_DISABLE_LASER = 18;

    /**
     * @internal
     */
    const FUNCTION_IS_LASER_ENABLED = 19;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const THRESHOLD_OPTION_OFF = 'x';
    const THRESHOLD_OPTION_OUTSIDE = 'o';
    const THRESHOLD_OPTION_INSIDE = 'i';
    const THRESHOLD_OPTION_SMALLER = '<';
    const THRESHOLD_OPTION_GREATER = '>';
    const MODE_DISTANCE = 0;
    const MODE_VELOCITY_MAX_13MS = 1;
    const MODE_VELOCITY_MAX_32MS = 2;
    const MODE_VELOCITY_MAX_64MS = 3;
    const MODE_VELOCITY_MAX_127MS = 4;

    const DEVICE_IDENTIFIER = 255;

    const DEVICE_DISPLAY_NAME = "Laser Range Finder Bricklet";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_DISTANCE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_VELOCITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DISTANCE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DISTANCE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_VELOCITY_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_VELOCITY_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_MOVING_AVERAGE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_MOVING_AVERAGE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_MODE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_MODE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_ENABLE_LASER] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_DISABLE_LASER] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_IS_LASER_ENABLED] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_DISTANCE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_VELOCITY] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_DISTANCE_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_VELOCITY_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_DISTANCE] = 'callbackWrapperDistance';
        $this->callbackWrappers[self::CALLBACK_VELOCITY] = 'callbackWrapperVelocity';
        $this->callbackWrappers[self::CALLBACK_DISTANCE_REACHED] = 'callbackWrapperDistanceReached';
        $this->callbackWrappers[self::CALLBACK_VELOCITY_REACHED] = 'callbackWrapperVelocityReached';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the measured distance. The value has a range of 0 to 4000
     * and is given in cm.
     * 
     * The Laser Range Finder Bricklet knows different modes. Distances
     * are only measured in the distance measurement mode,
     * see BrickletLaserRangeFinder::setMode(). Also the laser has to be enabled, see
     * BrickletLaserRangeFinder::enableLaser().
     * 
     * If you want to get the distance periodically, it is recommended to
     * use the callback BrickletLaserRangeFinder::CALLBACK_DISTANCE and set the period with 
     * BrickletLaserRangeFinder::setDistanceCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getDistance()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DISTANCE, $payload);

        $payload = unpack('v1distance', $data);

        return $payload['distance'];
    }

    /**
     * Returns the measured velocity. The value has a range of -12800 to 12700
     * and is given in 1/100 m/s.
     * 
     * The Laser Range Finder Bricklet knows different modes. Velocity 
     * is only measured in the velocity measurement modes, 
     * see BrickletLaserRangeFinder::setMode(). Also the laser has to be enabled, see
     * BrickletLaserRangeFinder::enableLaser().
     * 
     * If you want to get the velocity periodically, it is recommended to
     * use the callback BrickletLaserRangeFinder::CALLBACK_VELOCITY and set the period with 
     * BrickletLaserRangeFinder::setVelocityCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getVelocity()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_VELOCITY, $payload);

        $payload = unpack('v1velocity', $data);

        return IPConnection::fixUnpackedInt16($payload, 'velocity');
    }

    /**
     * Sets the period in ms with which the BrickletLaserRangeFinder::CALLBACK_DISTANCE callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletLaserRangeFinder::CALLBACK_DISTANCE is only triggered if the distance value has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setDistanceCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_DISTANCE_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletLaserRangeFinder::setDistanceCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getDistanceCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickletLaserRangeFinder::CALLBACK_VELOCITY callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletLaserRangeFinder::CALLBACK_VELOCITY is only triggered if the velocity value has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setVelocityCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_VELOCITY_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletLaserRangeFinder::setVelocityCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getVelocityCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_VELOCITY_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the thresholds for the BrickletLaserRangeFinder::CALLBACK_DISTANCE_REACHED callback. 
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the distance value is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the distance value is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the distance value is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the distance value is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0).
     * 
     * @param string $option
     * @param int $min
     * @param int $max
     * 
     * @return void
     */
    public function setDistanceCallbackThreshold($option, $min, $max)
    {
        $payload = '';
        $payload .= pack('c', ord($option));
        $payload .= pack('v', $min);
        $payload .= pack('v', $max);

        $this->sendRequest(self::FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletLaserRangeFinder::setDistanceCallbackThreshold().
     * 
     * 
     * @return array
     */
    public function getDistanceCallbackThreshold()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/v1min/v1max', $data);

        $result['option'] = chr($payload['option']);
        $result['min'] = $payload['min'];
        $result['max'] = $payload['max'];

        return $result;
    }

    /**
     * Sets the thresholds for the BrickletLaserRangeFinder::CALLBACK_VELOCITY_REACHED callback. 
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the velocity is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the velocity is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the velocity is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the velocity is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0).
     * 
     * @param string $option
     * @param int $min
     * @param int $max
     * 
     * @return void
     */
    public function setVelocityCallbackThreshold($option, $min, $max)
    {
        $payload = '';
        $payload .= pack('c', ord($option));
        $payload .= pack('v', $min);
        $payload .= pack('v', $max);

        $this->sendRequest(self::FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletLaserRangeFinder::setVelocityCallbackThreshold().
     * 
     * 
     * @return array
     */
    public function getVelocityCallbackThreshold()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/v1min/v1max', $data);

        $result['option'] = chr($payload['option']);
        $result['min'] = IPConnection::fixUnpackedInt16($payload, 'min');
        $result['max'] = IPConnection::fixUnpackedInt16($payload, 'max');

        return $result;
    }

    /**
     * Sets the period in ms with which the threshold callbacks
     * 
     * * BrickletLaserRangeFinder::CALLBACK_DISTANCE_REACHED,
     * * BrickletLaserRangeFinder::CALLBACK_VELOCITY_REACHED,
     * 
     * are triggered, if the thresholds
     * 
     * * BrickletLaserRangeFinder::setDistanceCallbackThreshold(),
     * * BrickletLaserRangeFinder::setVelocityCallbackThreshold(),
     * 
     * keep being reached.
     * 
     * The default value is 100.
     * 
     * @param int $debounce
     * 
     * @return void
     */
    public function setDebouncePeriod($debounce)
    {
        $payload = '';
        $payload .= pack('V', $debounce);

        $this->sendRequest(self::FUNCTION_SET_DEBOUNCE_PERIOD, $payload);
    }

    /**
     * Returns the debounce period as set by BrickletLaserRangeFinder::setDebouncePeriod().
     * 
     * 
     * @return int
     */
    public function getDebouncePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DEBOUNCE_PERIOD, $payload);

        $payload = unpack('V1debounce', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'debounce');
    }

    /**
     * Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
     * for the distance and velocity.
     * 
     * Setting the length to 0 will turn the averaging completely off. With less
     * averaging, there is more noise on the data.
     * 
     * The range for the averaging is 0-30.
     * 
     * The default value is 10.
     * 
     * @param int $distance_average_length
     * @param int $velocity_average_length
     * 
     * @return void
     */
    public function setMovingAverage($distance_average_length, $velocity_average_length)
    {
        $payload = '';
        $payload .= pack('C', $distance_average_length);
        $payload .= pack('C', $velocity_average_length);

        $this->sendRequest(self::FUNCTION_SET_MOVING_AVERAGE, $payload);
    }

    /**
     * Returns the length moving average as set by BrickletLaserRangeFinder::setMovingAverage().
     * 
     * 
     * @return array
     */
    public function getMovingAverage()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MOVING_AVERAGE, $payload);

        $payload = unpack('C1distance_average_length/C1velocity_average_length', $data);

        $result['distance_average_length'] = $payload['distance_average_length'];
        $result['velocity_average_length'] = $payload['velocity_average_length'];

        return $result;
    }

    /**
     * The LIDAR has five different modes. One mode is for distance
     * measurements and four modes are for velocity measurements with
     * different ranges.
     * 
     * The following modes are available:
     * 
     * * 0: Distance is measured with resolution 1.0 cm and range 0-400 cm
     * * 1: Velocity is measured with resolution 0.1 m/s and range is 0-12.7 m/s
     * * 2: Velocity is measured with resolution 0.25 m/s and range is 0-31.75 m/s
     * * 3: Velocity is measured with resolution 0.5 m/s and range is 0-63.5 m/s
     * * 4: Velocity is measured with resolution 1.0 m/s and range is 0-127 m/s
     * 
     * The default mode is 0 (distance is measured).
     * 
     * @param int $mode
     * 
     * @return void
     */
    public function setMode($mode)
    {
        $payload = '';
        $payload .= pack('C', $mode);

        $this->sendRequest(self::FUNCTION_SET_MODE, $payload);
    }

    /**
     * Returns the mode as set by BrickletLaserRangeFinder::setMode().
     * 
     * 
     * @return int
     */
    public function getMode()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MODE, $payload);

        $payload = unpack('C1mode', $data);

        return $payload['mode'];
    }

    /**
     * Activates the laser of the LIDAR.
     * 
     * We recommend that you wait 250ms after enabling the laser before
     * the first call of BrickletLaserRangeFinder::getDistance() to ensure stable measurements.
     * 
     * 
     * @return void
     */
    public function enableLaser()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_ENABLE_LASER, $payload);
    }

    /**
     * Deactivates the laser of the LIDAR.
     * 
     * 
     * @return void
     */
    public function disableLaser()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DISABLE_LASER, $payload);
    }

    /**
     * Returns *true* if the laser is enabled, *false* otherwise.
     * 
     * 
     * @return bool
     */
    public function isLaserEnabled()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_IS_LASER_ENABLED, $payload);

        $payload = unpack('C1laser_enabled', $data);

        return (bool)$payload['laser_enabled'];
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperDistance($data)
    {
        $result = array();
        $payload = unpack('v1distance', $data);

        array_push($result, $payload['distance']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_DISTANCE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_DISTANCE], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperVelocity($data)
    {
        $result = array();
        $payload = unpack('v1velocity', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'velocity'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_VELOCITY]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_VELOCITY], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperDistanceReached($data)
    {
        $result = array();
        $payload = unpack('v1distance', $data);

        array_push($result, $payload['distance']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_DISTANCE_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_DISTANCE_REACHED], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperVelocityReached($data)
    {
        $result = array();
        $payload = unpack('v1velocity', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'velocity'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_VELOCITY_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_VELOCITY_REACHED], $result);
    }
}

?>
