<?php

/* ***********************************************************
 * This file was automatically generated on 2016-06-30.      *
 *                                                           *
 * PHP Bindings Version 2.1.9                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Measures CO2 concentration in ppm
 */
class BrickletCO2 extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletCO2::setCO2ConcentrationCallbackPeriod(). The parameter is the CO2 concentration of the
     * sensor.
     * 
     * BrickletCO2::CALLBACK_CO2_CONCENTRATION is only triggered if the CO2 concentration has changed since the
     * last triggering.
     */
    const CALLBACK_CO2_CONCENTRATION = 8;

    /**
     * This callback is triggered when the threshold as set by
     * BrickletCO2::setCO2ConcentrationCallbackThreshold() is reached.
     * The parameter is the CO2 concentration.
     * 
     * If the threshold keeps being reached, the callback is triggered periodically
     * with the period as set by BrickletCO2::setDebouncePeriod().
     */
    const CALLBACK_CO2_CONCENTRATION_REACHED = 9;


    /**
     * @internal
     */
    const FUNCTION_GET_CO2_CONCENTRATION = 1;

    /**
     * @internal
     */
    const FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD = 3;

    /**
     * @internal
     */
    const FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD = 5;

    /**
     * @internal
     */
    const FUNCTION_SET_DEBOUNCE_PERIOD = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_DEBOUNCE_PERIOD = 7;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const THRESHOLD_OPTION_OFF = 'x';
    const THRESHOLD_OPTION_OUTSIDE = 'o';
    const THRESHOLD_OPTION_INSIDE = 'i';
    const THRESHOLD_OPTION_SMALLER = '<';
    const THRESHOLD_OPTION_GREATER = '>';

    const DEVICE_IDENTIFIER = 262;

    const DEVICE_DISPLAY_NAME = "CO2 Bricklet";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_CO2_CONCENTRATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_CO2_CONCENTRATION] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_CO2_CONCENTRATION_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_CO2_CONCENTRATION] = 'callbackWrapperCO2Concentration';
        $this->callbackWrappers[self::CALLBACK_CO2_CONCENTRATION_REACHED] = 'callbackWrapperCO2ConcentrationReached';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the measured CO2 concentration. The value is in 
     * `ppm (parts per million) <https://en.wikipedia.org/wiki/Parts-per_notation>`__
     * and between 0 to 10000.
     * 
     * If you want to get the CO2 concentration periodically, it is recommended to use the
     * callback BrickletCO2::CALLBACK_CO2_CONCENTRATION and set the period with
     * BrickletCO2::setCO2ConcentrationCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getCO2Concentration()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CO2_CONCENTRATION, $payload);

        $payload = unpack('v1co2_concentration', $data);

        return $payload['co2_concentration'];
    }

    /**
     * Sets the period in ms with which the BrickletCO2::CALLBACK_CO2_CONCENTRATION callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletCO2::CALLBACK_CO2_CONCENTRATION is only triggered if the CO2 concentration has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setCO2ConcentrationCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletCO2::setCO2ConcentrationCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getCO2ConcentrationCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the thresholds for the BrickletCO2::CALLBACK_CO2_CONCENTRATION_REACHED callback.
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the CO2 concentration is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the CO2 concentration is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the CO2 concentration is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the CO2 concentration is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0).
     * 
     * @param string $option
     * @param int $min
     * @param int $max
     * 
     * @return void
     */
    public function setCO2ConcentrationCallbackThreshold($option, $min, $max)
    {
        $payload = '';
        $payload .= pack('c', ord($option));
        $payload .= pack('v', $min);
        $payload .= pack('v', $max);

        $this->sendRequest(self::FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletCO2::setCO2ConcentrationCallbackThreshold().
     * 
     * 
     * @return array
     */
    public function getCO2ConcentrationCallbackThreshold()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/v1min/v1max', $data);

        $result['option'] = chr($payload['option']);
        $result['min'] = $payload['min'];
        $result['max'] = $payload['max'];

        return $result;
    }

    /**
     * Sets the period in ms with which the threshold callbacks
     * 
     * * BrickletCO2::CALLBACK_CO2_CONCENTRATION_REACHED,
     * 
     * are triggered, if the thresholds
     * 
     * * BrickletCO2::setCO2ConcentrationCallbackThreshold(),
     * 
     * keep being reached.
     * 
     * The default value is 100.
     * 
     * @param int $debounce
     * 
     * @return void
     */
    public function setDebouncePeriod($debounce)
    {
        $payload = '';
        $payload .= pack('V', $debounce);

        $this->sendRequest(self::FUNCTION_SET_DEBOUNCE_PERIOD, $payload);
    }

    /**
     * Returns the debounce period as set by BrickletCO2::setDebouncePeriod().
     * 
     * 
     * @return int
     */
    public function getDebouncePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DEBOUNCE_PERIOD, $payload);

        $payload = unpack('V1debounce', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'debounce');
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperCO2Concentration($data)
    {
        $result = array();
        $payload = unpack('v1co2_concentration', $data);

        array_push($result, $payload['co2_concentration']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_CO2_CONCENTRATION]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_CO2_CONCENTRATION], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperCO2ConcentrationReached($data)
    {
        $result = array();
        $payload = unpack('v1co2_concentration', $data);

        array_push($result, $payload['co2_concentration']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_CO2_CONCENTRATION_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_CO2_CONCENTRATION_REACHED], $result);
    }
}

?>
